
MarketActor subclass: #Customer
  instanceVariableNames: 
    'counter checker items leaving '
  classVariableNames: 
    'MinItems MaxItems '
  poolDictionaries: '' !

!Customer class methods !

alternateImageName 
    ^'CustomerReaching'.!

imageName  
    ^'Customer'.!

new
    MinItems isNil ifTrue:[MinItems := 5.  MaxItems := 25].
    ^super new.! !


!Customer methods !

cartIsEmpty 
    ^items <= 0.!

counter:aCheckoutCounter  
    counter := aCheckoutCounter.!

gotIt
    self display;  sleep:1.!

initialize
    items := RandomNumber from:MinItems to:MaxItems.
    leaving := false.
    super initialize.!

leaveStore
    running
        ifTrue:[
            self
                update;
                moveTo:counter exitPosition;
                send:#nextCustomer to:counter.
            running := false.
            leaving := true].!

moveForward
    running ifTrue:[self moveBy:0 @ self height].!

moveToCheckout
    checker := self receive.
    running
        ifTrue:[
            self
                moveTo:counter checkoutPosition;
                send:#checkOutCustomer to:checker with:self;
                update.
            self removeItemFromCart].!

moveToEndOfLine
    running ifTrue:[self moveTo:counter endOfLinePosition].!

release
    checker := nil.  counter := nil.  super release.!

removeItemFromCart
    running
        ifTrue:[
            self cartIsEmpty
                ifTrue:[self leaveStore]
                ifFalse:[
                    self
                        update;
                        animate;
                        send:#takeItem to:checker.
                    items := items - 1]].!

shutdown
    super shutdown.
    leaving ifTrue:[self release].!

update
    (running and:[counter notNil])
        ifTrue:[self send:#update to:counter with:items].! !
